﻿using System;
using System.Threading.Tasks;

namespace Grpc.Core.ServiceHost
{
    class Program
    {
        const string Host = "localhost";
        const int Port = 50051;

        static async Task Main(string[] args)
        {
            Server server = new Server();
            server.Services.Add(SharedLib.Generated.CalculatorService.BindService(
                new ServiceLib.CalculatorService()));
            server.Services.Add(SharedLib.Generated.BidirectionalCalculatorService.BindService(
                new gRpcServiceLib.BidirectionalCalculatorService()));
            server.Ports.Add(new ServerPort(Host, Port, ServerCredentials.Insecure));
            server.Start();

            Console.WriteLine($"The service is ready at {Host} on port {Port}.");
            Console.WriteLine("Press any key to stop the service...");
            Console.ReadLine();

            await server.ShutdownAsync();
        }
    }
}