﻿using Grpc.Core;
using Grpc.DotNet.SharedLib.Generated;
using System.Threading.Tasks;

namespace Grpc.DotNet.ServiceLib
{
    public class CalculatorService : SharedLib.Generated.CalculatorService.CalculatorServiceBase
    {
        public override Task<CalculatorReply> Add(CalculatorRequest request, ServerCallContext context) =>
            Task.FromResult(new CalculatorReply() { Result = request.N1 + request.N2 });

        public override Task<CalculatorReply> Subtract(CalculatorRequest request, ServerCallContext context) =>
            Task.FromResult(new CalculatorReply() { Result = request.N1 - request.N2 });

        public override Task<CalculatorReply> Multiply(CalculatorRequest request, ServerCallContext context) =>
            Task.FromResult(new CalculatorReply() { Result = request.N1 * request.N2 });

        public override Task<CalculatorReply> Divide(CalculatorRequest request, ServerCallContext context)
        {
            if (request.N2 == 0)
                throw new RpcException(new Status(StatusCode.InvalidArgument, "Divide by zero attempt."));

            return Task.FromResult(new CalculatorReply() { Result = request.N1 / request.N2 });
        }
    }
}